<?php

namespace Drupal\search_api_decoupled_autocomplete\Controller;

use Drupal\search_api_autocomplete\Controller\AutocompleteController;
use Drupal\search_api_decoupled\SearchApiEndpointInterface;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

/**
 * Controller class for autocomplete responses.
 *
 * @package Drupal\search_api_decoupled_autocomplete\Controller
 */
class SearchApiEndpointAutocompleteController extends AutocompleteController {

  /**
   * Returns the autocomplete results.
   *
   * @param \Drupal\search_api_decoupled\SearchApiEndpointInterface $search_api_endpoint
   *   The search api endpoint.
   * @param \Symfony\Component\HttpFoundation\Request $request
   *   The current request.
   */
  public function searchResults(SearchApiEndpointInterface $search_api_endpoint, Request $request) {
    /** @var \Drupal\search_api_autocomplete\SearchInterface $search */
    $search = $this->entityTypeManager()->getStorage('search_api_autocomplete_search')->load($search_api_endpoint->id());
    if ($search) {
      return parent::autocomplete($search, $request);
    }
    return new JsonResponse([]);
  }

}
